<?php

define('YOUTUBE', 'www.youtube.com');
define('YOUTUBE_INFO', '/watch?v=%s');
define('YOUTUBE_VIDEO', '/get_video.php?fmt=%s&video_id=%s&t=%s');

function error($msg) {
	header($_SERVER['SERVER_PROTOCOL'].' 404 Not Found.');
	die($msg);
}

$id = '';
$url = '';
if ($_SERVER['QUERY_STRING']) {
	$url = $_SERVER['QUERY_STRING'];
	$idregexp = '[a-zA-Z0-9_-]{11}';
	if (preg_match('~^'.$idregexp.'$~', $url))
		$id = $url;
	elseif (preg_match('~^https?://([a-z0-9][a-z0-9]*\\.)*youtube\\.com/.*?\\?(.*?&)*v=('.$idregexp.')~i', $url, $parts))
		$id = $parts[3];
}

if (!$id) {
	error($url ? $url.' is not a valid YouTube URL.' : 'YouTube URL not provided.');
}

$page = file_get_contents($url = sprintf('http://'.YOUTUBE.YOUTUBE_INFO, $id), 0, NULL, 0, 131072);
if (!$page) {
	error('Failed to download page '.$url);
}

$json = null;
if (preg_match_all('~\.setConfig\s*\(\s*(\{.*?\})\s*\)\s*;~is', $page, $matches, PREG_SET_ORDER)) {
	foreach($matches as $match) {
		$jsontext = preg_replace('~\'\s*:\s*\(.*?\),~is', '\': null,', $match[1]);
		$jsontext = strtr($jsontext, "'", '"');
		//echo "<pre style='background-color: #ffffe0;'>"; echo htmlspecialchars($jsontext); echo "</pre>";
		$jsontemp = json_decode($jsontext, TRUE);
		//echo "<pre style='background-color: #ffe0e0'>"; print_r($jsontemp); echo "</pre><hr>";
		if (isset($jsontemp['VIDEO_ID'])) {
			$json = $jsontemp;
			break;
		}
	}
}
if (!$json) {
	error('Failed to decode page '.$url);
}

//echo "<pre>"; print_r($json); echo "</pre>"; die();

$title = strtr($json['VIDEO_TITLE'], '\\/:*?"<>|', '__;-.\'--;');
$hdavailable = $json['IS_HD_AVAILABLE'];
$options = $json['SWF_ARGS'];

// Download using file functions
$videourl = 'http://'.YOUTUBE.sprintf(YOUTUBE_VIDEO, ($hdavailable ? '22' : '18'), $options['video_id'], $options['t']);
$filename = $title.($hdavailable ? '.mp4' : '.flv');

if ($fp = fopen($videourl, 'rb')) {

	$length = 0;
	if ($meta = stream_get_meta_data($fp)) {
		if (isset($meta['wrapper_data'])) {
			foreach($meta['wrapper_data'] as $data)
				if (preg_match('~^Content-length:\\s*([0-9]+)\\s*$~i', $data, $x)) {
					$length = $x[1];
				}
		}
	}

	header('Content-type: video/x-flv');
	if ($length)
		header('Content-length: '.$length);
	header('Content-disposition: attachment; filename='.$filename);

	fpassthru($fp);
	fclose(fp);

} else {
	error('Can\'t download video file '.$videourl);
}
